# PostgreSQL Configuration for groceryAggregator

This repository/directory was created as part of my thesis and contains configuration files and Docker settings for PostgreSQL, specifically adapted for the groceryAggregator-be (backend) applications. The goal is to provide you with a simple and efficient way to set up a database for this web application, which focuses on aggregating information from various online grocery stores in the Czech Republic. Thanks to automation through Docker and Docker Compose, the entire setup process is greatly simplified, allowing for immediate testing possibilities.

## Database Access Information

For testing and educational reasons, the following access details are freely available.

After successfully launching the PostgreSQL container, you can access the database using the following credentials:

- **Username**: postgres
- **Password**: su
- **Database Name**: groceryAggregator

Ensure that the database connection settings in groceryAggregator-be are the same.

## Getting Started

Follow these steps to easily launch PostgreSQL and integrate it with the groceryAggregator applications.

### Prerequisites

Before starting, make sure you have installed Docker and Docker Compose (in the latest versions, they are usually included with Docker). These tools are essential for the automatic setup and launching of PostgreSQL. If you do not have Docker yet, visit the [official Docker page](https://www.docker.com/get-started) and follow the instructions for installation.

### Launching PostgreSQL

1. Open a terminal or command line.
2. Navigate to the directory of this repository.
3. Start the containers using Docker Compose:

    ```
    docker-compose up
    ```

    Alternatively, you can use `start.cmd` (for Windows) or `start.sh` (for Unix/Linux) for easy launching:

    ```
    ./start.cmd
    ```

    or

    ```
    ./start.sh
    ```

This downloads the necessary Docker image (PostgreSQL), creates and starts the container, and sets up the environment with the specified settings.

## Technologies Used

- [Docker](https://www.docker.com/) - Software containerization.
- [Docker Compose](https://docs.docker.com/compose/) - A tool for defining and running multi-container Docker applications.
- [PostgreSQL](https://www.postgresql.org/) - Open Source Relational Database.
