package cz.gottlieb.groceryAggregator.configs.connectors.impl;

import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Profile;
import org.springframework.stereotype.Component;

@Slf4j
@Component
@Profile("production | dev-live")
public class BillaConfigProdImpl extends BillaConfigBaseImpl {
    private static final String serverApiUrl = serverBaseUrl + "/api";
    private static final String serverOrderUrl = serverBaseUrl + "/kosik";

    private static final int logTimeMinutes = 10;

    private static final int deliveryPrice = 0;
    private static final int minimalOrderPrice = 500;
    private static final int minimalFreeDeliveryPrice = 500;

    @Override
    public void setup() {
        log.info("Setting up BillaConfig for PRODUCTION environment.");
    }

    @Override
    public String getServerBaseUrl() {
        return serverBaseUrl;
    }

    @Override
    public String getServerApiUrl() {
        return serverApiUrl;
    }

    @Override
    public String getServerOrderUrl() {
        return serverOrderUrl;
    }

    @Override
    public int getLogTimeMinutes() {
        return logTimeMinutes;
    }

    @Override
    public int getDeliveryPrice() {
        return deliveryPrice;
    }

    @Override
    public int getMinimalOrderPrice() {
        return minimalOrderPrice;
    }

    @Override
    public int getMinimalFreeDeliveryPrice() {
        return minimalFreeDeliveryPrice;
    }
}
