package cz.gottlieb.groceryAggregator.configs.connectors.impl;

import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Profile;
import org.springframework.stereotype.Component;

@Slf4j
@Component
@Profile("dev-mock")
public class RohlikConfigDevImpl extends RohlikConfigBaseImpl {
    private static final String serverApiUrl = "https://localhost:3001";
    private static final String serverOrderUrl = serverBaseUrl + "/objednavka/prehled-kosiku";

    private static final int logTimeMinutes = 10;

    private static final int deliveryPrice = 50;
    private static final int minimalOrderPrice = 750;
    private static final int minimalFreeDeliveryPrice = 1500;

    @Override
    public void setup() {
        log.info("Setting up RohlikConfig for DEV environment.");
    }

    @Override
    public String getServerBaseUrl() {
        return serverBaseUrl;
    }

    @Override
    public String getServerCdnUrl() {
        return serverCdnUrl;
    }

    @Override
    public String getServerApiUrl() {
        return serverApiUrl;
    }

    @Override
    public String getServerOrderUrl() {
        return serverOrderUrl;
    }

    @Override
    public int getLogTimeMinutes() {
        return logTimeMinutes;
    }

    @Override
    public int getDeliveryPrice() {
        return deliveryPrice;
    }

    @Override
    public int getMinimalOrderPrice() {
        return minimalOrderPrice;
    }

    @Override
    public int getMinimalFreeDeliveryPrice() {
        return minimalFreeDeliveryPrice;
    }

}
