package cz.gottlieb.groceryAggregator.configs.restTemplate;

import cz.gottlieb.groceryAggregator.utils.Constants;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpRequest;
import org.springframework.http.client.ClientHttpRequestExecution;
import org.springframework.http.client.ClientHttpRequestInterceptor;
import org.springframework.http.client.ClientHttpResponse;
import org.springframework.stereotype.Component;
import org.springframework.web.context.annotation.SessionScope;

import java.io.IOException;

@Slf4j
@SessionScope
@Component
public class RohlikInterceptor implements ClientHttpRequestInterceptor {

    @Override
    public ClientHttpResponse intercept(HttpRequest request, byte[] body, ClientHttpRequestExecution execution) throws IOException {
        log.info(">>> intercept");

        setHeaders(request.getHeaders());

        ClientHttpResponse response = execution.execute(request, body);

/*
        List<String> setterCookies = response.getHeaders().get(HttpHeaders.SET_COOKIE);
        parse(setterCookies);
*/

        log.info("<<< intercept");
        return response;
    }

    private void setHeaders(HttpHeaders headers) {
        headers.set("Accept", "application/json");
        headers.set("Accept-Encoding", "identity"); //identity, br // gzip, deflate
        headers.set("Accept-Language", "cs-CZ,cs;q=0.9,en;q=0.8");
        headers.set("Referer", "https://www.rohlik.cz/?hp=true");
        headers.set("User-Agent", Constants.userAgent);
        headers.set("X-Origin", "WEB");
    }

}
