package cz.gottlieb.groceryAggregator.controllers.connectors;

import cz.gottlieb.groceryAggregator.annotation.CurrentUser;
import cz.gottlieb.groceryAggregator.dto.fe.FeItemRequestDto;
import cz.gottlieb.groceryAggregator.dto.fe.FeItemResponseDto;
import cz.gottlieb.groceryAggregator.dto.fe.FeProductResponseDto;
import cz.gottlieb.groceryAggregator.persistence.model.User;
import org.springframework.http.ResponseEntity;
import org.springframework.security.access.prepost.PreAuthorize;

import java.util.List;

public interface GroceryRestApi {
    ResponseEntity<List<FeProductResponseDto>> findByName(String name);

    ResponseEntity<List<FeItemResponseDto>> getCart(@CurrentUser User user);

    @PreAuthorize("hasAuthority('SCOPE_write')")
    ResponseEntity<List<FeItemResponseDto>> addToCart(FeItemRequestDto feItemRequestDto, @CurrentUser User user);

    @PreAuthorize("hasAuthority('SCOPE_write')")
    ResponseEntity<List<FeItemResponseDto>> changeCart(FeItemRequestDto feItemRequestDto, @CurrentUser User user);

    @PreAuthorize("hasAuthority('SCOPE_write')")
    ResponseEntity<Boolean> clearCart(@CurrentUser User user);

    ResponseEntity<Boolean> login(@CurrentUser User user);

    ResponseEntity<Boolean> logout();
}
