package cz.gottlieb.groceryAggregator.dto.billa;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

import java.util.List;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
@JsonInclude(JsonInclude.Include.NON_NULL)
public class BillaProductResponseDto {

    @JsonProperty("amount")
    public String amount;

    @JsonProperty("brand")
    public BillaBrandResponseDto brand;

    @JsonProperty("category")
    public String category;

    @JsonProperty("descriptionShort")
    public String descriptionShort;

    @JsonProperty("images")
    public List<String> images;

    @JsonProperty("name")
    public String name;

    @JsonProperty("packageLabel")
    public String packageLabel;

    @JsonProperty("packageLabelKey")
    public String packageLabelKey;

    @JsonProperty("parentCategories")
    public List<List<BillaParentCategoryResponseDto>> parentCategories;

    @JsonProperty("price")
    public BillaProductPriceResponseDto price;

    @JsonProperty("productId")
    public String productId;

    @JsonProperty("medical")
    public boolean medical;

    @JsonProperty("sku")
    public String sku;

    @JsonProperty("slug")
    public String slug;

    @JsonProperty("purchased")
    public boolean purchased;

    @JsonProperty("volumeLabelKey")
    public String volumeLabelKey;

    @JsonProperty("volumeLabelLong")
    public String volumeLabelLong;

    @JsonProperty("volumeLabelShort")
    public String volumeLabelShort;

    @JsonProperty("weight")
    public String weight;

    @JsonProperty("weightArticle")
    public boolean weightArticle;

    @JsonProperty("weightPieceArticle")
    public boolean weightPieceArticle;

    @JsonProperty("weightPerPiece")
    public Integer weightPerPiece;

    @JsonProperty("brandMarketing")
    public String brandMarketing;

    @JsonProperty("countryOfOrigin")
    public String countryOfOrigin;

    @JsonProperty("productMarketing")
    public String productMarketing;

    @JsonProperty("regulatedProductName")
    public String regulatedProductName;
}