package cz.gottlieb.groceryAggregator.dto.fe;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import cz.gottlieb.groceryAggregator.utils.GroceryEnum;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class FeItemRequestDto {

    private static final String COMPANY_REGEX = "^("
            + GroceryEnum.Constants.ROHLIK_VALUE + "|"
            + GroceryEnum.Constants.KOSIK_VALUE + "|"
            + GroceryEnum.Constants.BILLA_VALUE + ")$";

    @NotNull(message = "company is mandatory")
    @Pattern(regexp = COMPANY_REGEX, message = "Invalid value for field: company")
    private String company;

    @NotBlank(message = "originSku is mandatory")
    private String originSku;

    @NotNull(message = "quantity is mandatory")
    private Integer quantity;

    private String originItemId; // only in PUT requests (Rohlik, Billa)

}
