package cz.gottlieb.groceryAggregator.dto.rohlik;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import cz.gottlieb.groceryAggregator.utils.GroceryEnum;
import lombok.Data;

import java.util.ArrayList;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
@JsonInclude(JsonInclude.Include.NON_NULL)
public class RohlikItemResponseDto {

    @JsonProperty("productId")
    Long productId;

    @JsonProperty("orderFieldId")
    Long orderFieldId;

    @JsonProperty("imgPath")
    String imgPath;

    @JsonProperty("productName")
    String productName;

    @JsonProperty("link")
    String link;

    @JsonProperty("baseLink")
    String baseLink;

    @JsonProperty("quantity")
    Integer quantity;

    @JsonProperty("volume")
    String volume;

    @JsonProperty("unit")
    String unit;

    @JsonProperty("maxBasketAmount")
    Integer maxBasketAmount;

    @JsonProperty("maxBasketAmountReason")
    String maxBasketAmountReason;

    @JsonProperty("salePercents")
    Integer salePercents;

    @JsonProperty("originalPricePerUnit")
    String originalPricePerUnit;

    @JsonProperty("asPriceDiff")
    boolean asPriceDiff;

    @JsonProperty("billablePackagingPriceVAT")
    Integer billablePackagingPriceVAT;

    @JsonProperty("price")
    String price;

    @JsonProperty("recommendedPricePerUnit")
    String recommendedPricePerUnit;

    @JsonProperty("currency")
    String currency;

    @JsonProperty("companyName")
    String companyName;

    @JsonProperty("companyId")
    Integer companyId;

    @JsonProperty("textualAmount")
    String textualAmount;

    @JsonProperty("id")
    String id;

    @JsonProperty("primaryCategoryName")
    String primaryCategoryName;

    @JsonProperty("position")
    String position;

    @JsonProperty("parentCategoryIds")
    ArrayList<Integer> parentCategoryIds;

    @JsonProperty("semicaliber")
    boolean semicaliber;

    @JsonProperty("brand")
    String brand;

    @JsonProperty("availabilityDimension")
    Integer availabilityDimension;

    @JsonProperty("silent")
    boolean silent;

    @JsonProperty("favourite")
    boolean favourite;

    @JsonProperty("singlePieceDeposit")
    String singlePieceDeposit;

    @JsonProperty("deposit")
    String deposit;

    @JsonProperty("isLastMinute")
    boolean isLastMinute;

}
