package cz.gottlieb.groceryAggregator.dto.rohlik;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonSetter;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.Data;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
@JsonInclude(JsonInclude.Include.NON_NULL)
public class RohlikProductResponseDto {

    @JsonProperty("productId")
    private Long productId;

    @JsonProperty("productName")
    private String productName;

    @JsonProperty("imgPath")
    private String imgPath;

    @JsonProperty("textualAmount")
    private String textualAmount;

    @JsonProperty("unit")
    private String unit;

    @JsonProperty("deliveryRestriction")
    private String deliveryRestriction;

    @JsonProperty("baseLink")
    private String baseLink;

    @JsonProperty("maxBasketAmount")
    private Integer maxBasketAmount;

    @JsonProperty("price")
    private RohlikProductPriceResponseDto price;

    @JsonProperty("pricePerUnit")
    private RohlikProductPriceResponseDto pricePerUnit;

    @JsonProperty("isDiscounted")
    private boolean isDiscounted = false;

    @JsonProperty("discounted")
    private RohlikProductSalesResponseDto productSalesDto;

    @JsonSetter("sales")
    public void setDiscountPrices(JsonNode sales) {
        if (sales.size() != 1) {
            return;
        }
        JsonNode productSalesListNode = sales.get(0);

        ObjectMapper objectMapper = new ObjectMapper();
        RohlikProductSalesResponseDto myProdSales = objectMapper.convertValue(productSalesListNode, new TypeReference<RohlikProductSalesResponseDto>() {
        });

        productSalesDto = myProdSales;
        isDiscounted = myProdSales.isActive();
    }
}
