package cz.gottlieb.groceryAggregator.persistence.repository;

import cz.gottlieb.groceryAggregator.persistence.model.Product;
import cz.gottlieb.groceryAggregator.utils.GroceryEnum;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.Optional;

public interface ProductRepository extends JpaRepository<Product, Long> {

    Optional<Product> findByOriginSku(String originSku);

    @Query("select p from Product p where p.originSku = ?1 and p.company.name = ?2")
    Optional<Product> findByOriginSkuAndCompany_Name(String originSku, GroceryEnum name);

}