package cz.gottlieb.groceryAggregator.services.connectors;

import com.fasterxml.jackson.core.JsonProcessingException;
import cz.gottlieb.groceryAggregator.persistence.model.GroceryCredential;
import cz.gottlieb.groceryAggregator.persistence.model.Product;
import cz.gottlieb.groceryAggregator.persistence.model.ShoppingListItem;
import cz.gottlieb.groceryAggregator.utils.GroceryEnum;
import org.springframework.data.util.Pair;
import org.springframework.http.HttpStatus;
import org.springframework.lang.Nullable;

import java.util.List;

public interface GroceryService {

    Pair<HttpStatus, List<Product>> findProducts(String name) throws JsonProcessingException;

    Pair<HttpStatus, List<ShoppingListItem>> loadCart() throws JsonProcessingException;

    Pair<HttpStatus, List<ShoppingListItem>> addToCart(ShoppingListItem item) throws JsonProcessingException;

    Pair<HttpStatus, List<ShoppingListItem>> changeCart(ShoppingListItem item) throws JsonProcessingException;

    Pair<HttpStatus, List<ShoppingListItem>> removeFromCart(ShoppingListItem item) throws JsonProcessingException;

    HttpStatus login(GroceryCredential cred);

    HttpStatus logout();

    HttpStatus clearCart();

    GroceryEnum getType();

    List<Product> findProductsByName(String name, @Nullable GroceryCredential credential) throws JsonProcessingException;

    Product findProductByNameAndSkuOrThrow(String name, String originSku, @Nullable GroceryCredential credential);

}
