# GroceryAggregatorFe

This project, "grocery-aggregator-fe", was generated with [Angular CLI](https://github.com/angular/angular-cli) version 17.0.1.

## Description

Grocery Aggregator is a web application designed to compare grocery prices among various online shops in the Czech Republic. This application enables users to easily find the best prices for their needs and save money on online grocery shopping.

## Installation

Before running the development server or building the project, make sure to install all the required dependencies. Navigate to the project directory and run:

`npm install`

## Development server

For starting the development server, you can use the following npm scripts defined in your `package.json`:

- `npm start`: Runs the app in development mode using the live backend configuration. Equivalent to `ng serve --configuration=dev-live`, which connects to `http://localhost:8081`.
- `npm run start-mock`: Runs the app using mock backend data, ideal for offline development or testing. Equivalent to `ng serve --configuration=dev-mock`, which connects to `http://localhost:3030`.

Navigate to `http://localhost:4200/` after starting the server. The application will automatically reload if you change any of the source files.

## Code scaffolding

Run `ng generate component component-name` to generate a new component. You can also use `ng generate directive|pipe|service|class|guard|interface|enum|module`.

## Build

Run `npm run build` to build the project. The build artifacts will be stored in the `dist/` directory.

## OAuth2 Configuration

The application requires OAuth2 setup for authentication and authorization. This involves specific configuration in the `app.module.ts` file. Below is a brief overview of key parameters that need to be set:

- `authority`: URL of your identity provider (e.g., Keycloak).
- `redirectUrl`: URL to redirect to after successful login.
- `postLogoutRedirectUri`: URL to redirect to after logout.
- `clientId`: Identifier of your application with the identity provider.
- `scope`: Required scope of permissions.
- `responseType`: The type of response desired from the identity provider.
- `silentRenew`: Enables silent token renewal.
- `useRefreshToken`: Uses refresh tokens to maintain the session.
- `logLevel`: Logging level for debugging.
- `ignoreNonceAfterRefresh`: Ignores nonce after token refresh.
- `secureRoutes`: List of routes that require security.

For detailed configuration and examples, refer to the `OAuth2 Configuration` section in the `app.module.ts` file.

## Environment Configurations

The project includes different environment configurations:

- Production: Uses the Azure backend (e.g. `http://aggr-be.azurewebsites.net`).
- Development (live): Uses a local backend server (`http://localhost:8081`).
- Development (mock): Uses Mockoon for mock data (`http://localhost:3030`).

## Dependencies

The project has the following main dependencies:

- Angular core and related modules like Animations, CDK, Common, Compiler, Forms, Material, Platform-Browser, Platform-Browser-Dynamic, and Router at version 17.0.0 or above.
- Angular Auth OIDC Client for authentication, version 16.0.1.
- RxJS, version ~7.8.0.
- tslib, version ^2.3.0.
- zone.js, version ~0.14.2.

## Development Dependencies

For development, the project uses:

- Angular CLI version 17.0.1.
- Angular DevKit Build Angular version 17.0.2.
- Angular Compiler CLI version 17.0.0.
- TypeScript, version ~5.2.2.
- Testing tools like Jasmine, Karma, and related plugins.

## License

This project is created solely for educational purposes and is not intended for distribution or commercial use. All content is provided without any warranties.

## Further help

To get more help on the Angular CLI use `ng help` or go check out the [Angular CLI Overview and Command Reference](https://angular.io/cli) page.
