import {Component} from '@angular/core';
import {MatDialogRef} from "@angular/material/dialog";

@Component({
  selector: 'app-dialog-new-shopping-list',
  templateUrl: './dialog-new-shopping-list.component.html',
  styleUrl: './dialog-new-shopping-list.component.scss'
})
export class DialogNewShoppingListComponent {

  constructor(private dialog: MatDialogRef<DialogNewShoppingListComponent>) {
  }

  onNoClick(): void {
    this.dialog.close();
  }

  onCreateClick(input: HTMLInputElement) {
    if (input.checkValidity() && input.value.trim().length > 0) {
      this.dialog.close(input.value);
    }
  }
}
