import {Component, OnInit} from '@angular/core';
import {GroceryCredentialDto} from "../../../dto/GroceryCredentialDto";
import {GroceryCredentialService} from "../../../services/rest/grocery-credential-service.service";

@Component({
  selector: 'app-grocery-credential',
  templateUrl: './grocery-credential.component.html',
  styleUrl: './grocery-credential.component.scss'
})
export class GroceryCredentialComponent implements OnInit {
  isHiding: boolean = true;
  isAddingNewItem: boolean = false;
  credentialDtos: GroceryCredentialDto[] = [];

  constructor(private credentialService: GroceryCredentialService) {
  }

  ngOnInit(): void {
    this.loadAllCredentials();
  }

  private loadAllCredentials(): void {
    this.credentialService.getAllCredentials().subscribe(credentials => {
      this.credentialDtos = credentials;
    });
  }

}
