import {Component, OnInit} from '@angular/core';
import {WatchDogDto} from "../../../dto/WatchDogDto";
import {WatchDogService} from "../../../services/rest/watch-dog.service";

@Component({
  selector: 'app-watch-dog',
  templateUrl: './watch-dog.component.html',
  styleUrl: './watch-dog.component.scss'
})
export class WatchDogComponent implements OnInit {
  isAddingNewItem: boolean = false;
  watchDogDtos: WatchDogDto[] = [];

  constructor(private watchDogService: WatchDogService) {
  }

  ngOnInit(): void {
    this.loadAllWatchDogs();
  }

  private loadAllWatchDogs(): void {
    this.watchDogService.getAllWatchDogs().subscribe(watchDogs => {
      this.watchDogDtos = watchDogs;
    });
  }
}
