import {Component, OnInit} from '@angular/core';
import {ShoppingListDto} from "../../../dto/ShoppingListDto";
import {GroceryCredentialService} from "../../../services/rest/grocery-credential-service.service";
import {ShoppingListService} from "../../../services/rest/shopping-list.service";

@Component({
  selector: 'app-shopping-lists',
  templateUrl: './shopping-lists.component.html',
  styleUrl: './shopping-lists.component.scss'
})
export class ShoppingListsComponent implements OnInit {
  isHiding: boolean = true;
  isAddingNewItem: boolean = false;
  shoppingListDtos: ShoppingListDto[] = [];

  constructor(private shoppingListService: ShoppingListService) {
  }

  ngOnInit(): void {
    this.loadAllShoppingLists();
  }

  loadAllShoppingLists(): void {
    this.shoppingListService.getAllShoppingLists().subscribe(listDtos => {
      this.shoppingListDtos = listDtos;
    });
  }
}
