import {Injectable} from '@angular/core';
import {ActivatedRouteSnapshot, CanActivate, Router, RouterStateSnapshot, UrlTree} from '@angular/router';
import {OidcSecurityService} from 'angular-auth-oidc-client';
import {Observable, take} from 'rxjs';
import {map} from 'rxjs/operators';

@Injectable({providedIn: 'root'})
export class AuthorizationGuard implements CanActivate {

  constructor(private oidcSecurityService: OidcSecurityService,
              private router: Router) {
  }

  canActivate(route: ActivatedRouteSnapshot, state: RouterStateSnapshot): Observable<boolean | UrlTree> {
    return this.oidcSecurityService.isAuthenticated$.pipe(
      take(1),
      map(({isAuthenticated}) => {
        // allow navigation if authenticated
        console.log(("isAuthenticated")); // TODO delete it
        console.log((isAuthenticated)); // TODO delete it

        if (isAuthenticated) {
          return true;
        }

        // redirect if not authenticated
        return this.router.parseUrl('/login');
      })
    );
  }
}
