import {Injectable} from '@angular/core';
import {catchError, Observable, tap} from "rxjs";
import {Constants} from "../../util/Constants";
import {HttpClient, HttpHeaders} from "@angular/common/http";
import {FuncsService} from "../funcs.service";

@Injectable({
  providedIn: 'root'
})
export class UserService {
  private url: string = Constants.SERVER_URL + '/user';

  httpOptions = {
    headers: new HttpHeaders({'Content-Type': 'application/json'})
  };

  constructor(private http: HttpClient,
              private funcsService: FuncsService) {
  }

  /** POST logout from the server */
  logout(): Observable<void> {
    const url = `${this.url}/logout`;

    return this.http.post<void>(url, null, this.httpOptions)
      .pipe(
        tap(_ => this.funcsService.log('fetched logout')),
        catchError(this.funcsService.handleError<void>('logout'))
      );
  }

}
